void MissionInit2(World *w) WSEC;
void MissionInit2(World *w)
{
	dbl X,Z;

 	#ifdef DEMO
 	clrGround = clrSand;
  	#else
   	clrGround = clrGrass;
   	#endif
	WorldCreate(w, 9);
    //our airbase
 	X=fdbl(-2000); Z=fdbl(6000);
 	GroupCreate(&(w->grp[0]),4);
    w->grp[0].cx = fdbl(-5)+X; w->grp[0].cy=0; w->grp[0].cz=fdbl(60)+Z; w->grp[0].R=fdbl(110);
    ObjectCube(&(w->grp[0].obj[3]),fdbl(-20)+X,fdbl(0),fdbl(0)+Z,  fdbl(10),fdbl(10),fdbl(30));
	ObjectCube(&(w->grp[0].obj[1]), fdbl(40)+X, fdbl(0), fdbl(120)+Z,  fdbl(10), fdbl(10), fdbl(30));
	ObjectCube(&(w->grp[0].obj[2]), fdbl(-20)+X, fdbl(0), fdbl(120)+Z,  fdbl(10), fdbl(10), fdbl(30));
 	ObjectSquare(&(w->grp[0].obj[0]), fdbl(10)+X, fdbl(-40)+Z, fdbl(10), fdbl(200), clrConcrete);
    
  	basex1 = X+fdbl(10); basex2 = X+fdbl(20);
  	basez1 = Z+fdbl(-40); basez2 = Z+fdbl(160);
    mx=fdbl(15)+X; my=fdbl(2); mz=fdbl(-20)+Z; mSpeed = fdbl(1); maSpeed=fdbl(0);
    mKurs=0; mKren=0; mTang=0; 
  
  	ebasex = fdbl(12000); ebasez = fdbl(6000);
  
	GroupRadar(&(w->grp[1]), fdbl(-1000), fdbl(6500));
  	GroupFarm(&(w->grp[2]), fdbl(5000), fdbl(6000));
  	GroupFarm(&(w->grp[3]), fdbl(-1000), fdbl(9000));
  	GroupFarm(&(w->grp[4]), fdbl(3000), fdbl(13000));
  	GroupFarm(&(w->grp[5]), fdbl(8000), fdbl(10000));
  	GroupFarm(&(w->grp[6]), fdbl(7000), fdbl(000));
  	GroupFarm(&(w->grp[7]), fdbl(3000), fdbl(1000));
  	GroupFarm(&(w->grp[8]), fdbl(-4000), fdbl(-1000));
    
    fgt[0].state=2; fgt[0].role=0; fgt[0].tgn=-1;// attack user
    fgt[0].tx = fdbl(12000); fgt[0].ty = fdbl(0); fgt[0].tz = fdbl(2000); 
    fgt[0].ax = fdbl(12500); fgt[0].ay = fdbl(200); fgt[0].az = fdbl(2000); 
    fgt[1].state=2; fgt[1].role=0; fgt[1].tgn=-1; // att usr
    fgt[1].tx = fdbl(11000); fgt[1].ty = fdbl(0); fgt[1].tz = fdbl(10000); 
    fgt[1].ax = fdbl(11500); fgt[1].ay = fdbl(300); fgt[1].az = fdbl(10000); 
    fgt[2].state=2; fgt[2].role=0; fgt[2].tgn=-1; 
    fgt[2].tx = fdbl(12000); fgt[2].ty = fdbl(0); fgt[2].tz = fdbl(14000); 
    fgt[2].ax = fdbl(12500); fgt[2].ay = fdbl(100); fgt[2].az = fdbl(14000); 
    fgt[3].state=2; fgt[3].role=2; fgt[3].tgn=1; // att radar
    fgt[3].tx = fdbl(-1000+5); fgt[3].ty = fdbl(0); fgt[3].tz = fdbl(6005); 
    fgt[3].ax = fdbl(12500); fgt[3].ay = fdbl(100); fgt[3].az = fdbl(6000); 
    fgt[0].Kurs = fdbl(270); fgt[1].Kurs = fdbl(270); fgt[2].Kurs = fdbl(270); fgt[3].Kurs = fdbl(270);
	nfgt = 4;    
}

void MissionZrk2(World *w) WSEC;
void MissionZrk2(World *w)
{
	Int16 x,f=0;
 	for(x=0;x<nfgt;x++)
  		if (fgt[x].state>0) f=1;
    if (!f) {
    	SetText("Mission complete!");
     	mcomplete=1;
     }
}

void MissionAct2(World *w, UInt32 tick) WSEC;
void MissionAct2(World *w, UInt32 tick)
{
	Int32 ang;
 	dbl dx,dy;
        if (w->grp[1].visible) { // rotate radar
        	dbl X=fdbl(-1000+2),Z=fdbl(6505);
        	ang = tick%360; 
         	while(ang<0) ang+=360;
         	dx = fmul(cosa[ang],fdbl(10));
          	dy = fmul(sina[ang],fdbl(10));
            if (w->grp[1].visible && w->grp[1].nobj>1) { //our
	           	w->grp[1].obj[2].dots[0].ax=X-dx; w->grp[1].obj[2].dots[0].az=Z-dy;
    	       	w->grp[1].obj[2].dots[3].ax=X-dx; w->grp[1].obj[2].dots[3].az=Z-dy;
        	   	w->grp[1].obj[2].dots[1].ax=X+dx; w->grp[1].obj[2].dots[1].az=Z+dy;
           		w->grp[1].obj[2].dots[2].ax=X+dx; w->grp[1].obj[2].dots[2].az=Z+dy;
             }
        }
}

void MissionDestroy2(Int16 tgn) WSEC;
void MissionDestroy2(Int16 tgn)
{
  switch(tgn) {
     case 1:SetText("Our radar is destroyed.");
     failed=1;
     break;
    }
}

void MissionMap2(World *w) WSEC;
void MissionMap2(World *w)
{
	EventType e;
 	Int32 x,y, cx,cy, fcx[16], fcy[16], i, rd;
  	Char capt[]="ARFFFFFFF";
 
  	if (w->grp[1].nobj>1) rd=1;
   	else rd=0;
	WinEraseWindow();
 	for(x=0; x<w->ngrp; x++)
		WinDrawChars(&(capt[x]), 1, fint(w->grp[x].cx)/125+54, 122- fint(w->grp[x].cz)/125); 	
 
 	WinDrawChars("A-Airbase, F-Farm", 17, 2, 140);
 	WinDrawChars("R-Radar", 7, 2, 150);
	
    
    for(x=0;x<160;x++) {
        if (x&2) continue;
        WinDrawPixel(140,x);
    }
    
    cx = fint(mx)/125+56; cy = 128- fint(mz)/125;
    x = fint(fmul(sina[fint(mKurs)],fdbl(5)));     y = fint(fmul(-cosa[fint(mKurs)],fdbl(5)));
	for(i=0;i<nfgt;i++) {
	    fcx[i] = fint(fgt[i].ax)/125+56; fcy[i] = 128- fint(fgt[i].az)/125;
    }    

 	if (rd){
      for(i=0;i<nfgt;i++)
      	if (fgt[i].state>0 && fcx[i]>=0 && fcx[i]<160 && fcy[i]>=0 && fcy[i]<160) {
	      WinInvertLine(fcx[i],fcy[i],fcx[i]+1,fcy[i]);
	      WinInvertLine(fcx[i],fcy[i]+1,fcx[i]+1,fcy[i]+1);
        }
    } else
        WinDrawChars("No radar info!", 14, 2, 1);
 do {
      EvtGetEvent (&e, 40);
      if (cx>=0 && cx<160 && cy>=0 && cy<160) {
	      WinInvertLine(cx,cy,cx+x,cy+y);
       	  WinInvertLine(cx+y/2, cy-x/2, cx-y/2, cy+x/2);
      }
      if (rd)
      for(i=0;i<nfgt;i++)
      	if (fgt[i].state>0 && fcx[i]>=0 && fcx[i]<160 && fcy[i]>=0 && fcy[i]<160) {
	      WinInvertLine(fcx[i],fcy[i],fcx[i]+1,fcy[i]);
	      WinInvertLine(fcx[i],fcy[i]+1,fcx[i]+1,fcy[i]+1);
        }
      //SysHandleEvent (&e);
    } while (e.eType!=keyDownEvent && e.eType!=penDownEvent);
}

void MissionBrief2(World *w) WSEC2;
void MissionBrief2(World *w)
{
	Char *s;
 	RectangleType rc;
  	Int16 done=0;
   	EventType e;
 	WinEraseWindow();
	WinDrawChars("MISSION BRIEFING",16,30,0);
	s = "This is an introductory mission.";
 	WinDrawChars(s, StrLen(s), 5, 10);
	s = "Enemy fighters advance from the";
 	WinDrawChars(s, StrLen(s), 5, 20); 
	s = "east intending to destroy our radar";
 	WinDrawChars(s, StrLen(s), 5, 30); 
	s = "station. You must take off from";
 	WinDrawChars(s, StrLen(s), 5, 40); 
	s = "our airbase and shoot down all";
 	WinDrawChars(s, StrLen(s), 5, 50); 
	s = "the enemy aircraft.";
 	WinDrawChars(s, StrLen(s), 5, 60); 

    rc.topLeft.x=120; rc.topLeft.y=140;
    rc.extent.x=20; rc.extent.y=15;
  	WinDrawRectangle(&rc,5);
   	WinEraseChars("Go",2,123,142);
    
    rc.topLeft.x=30; rc.topLeft.y=140;
    rc.extent.x=25; rc.extent.y=15;
  	WinDrawRectangle(&rc,5);
   	WinEraseChars("Map",3,33,142);
    
    do {
      EvtGetEvent (&e, evtWaitForever);
      //SysHandleEvent (&e);
	  if (e.eType == penDownEvent && e.screenY >140 && e.screenY <152 && e.screenX>120) done=1;
   	  if (e.eType == penDownEvent && e.screenY >140 && e.screenY <152 && e.screenX<80) {
      	MissionMap2(w);
       	MissionBrief2(w);
        done=1;
      }
    } while (!done);
}


