void MissionInit4(World *w) WSEC;
void MissionInit4(World *w)
{
	dbl X,Z;

 	clrGround = clrGrass;
	WorldCreate(w, 9);
    //our airbase
 	X=fdbl(10000); Z=fdbl(-2000);
 	GroupCreate(&(w->grp[0]),4);
    w->grp[0].cx = fdbl(-5)+X; w->grp[0].cy=0; w->grp[0].cz=fdbl(60)+Z; w->grp[0].R=fdbl(110);
    ObjectCube(&(w->grp[0].obj[3]),fdbl(40)+X,fdbl(0),fdbl(0)+Z,  fdbl(10),fdbl(10),fdbl(30));
	ObjectCube(&(w->grp[0].obj[1]), fdbl(-20)+X, fdbl(0), fdbl(120)+Z,  fdbl(10), fdbl(10), fdbl(30));
	ObjectCube(&(w->grp[0].obj[2]), fdbl(40)+X, fdbl(0), fdbl(120)+Z,  fdbl(10), fdbl(10), fdbl(30));
 	ObjectSquare(&(w->grp[0].obj[0]), fdbl(10)+X, fdbl(-40)+Z, fdbl(10), fdbl(200), clrConcrete);
    
  	basex1 = X+fdbl(10); basex2 = X+fdbl(20);
  	basez1 = Z+fdbl(-40); basez2 = Z+fdbl(160);
    mx=fdbl(15)+X; my=fdbl(2); mz=fdbl(-20)+Z; mSpeed = fdbl(1); maSpeed=fdbl(0);
    mKurs=0; mKren=0; mTang=0; 
  
  	ebasex = fdbl(12000); ebasez = fdbl(6000);
  
	GroupRadar(&(w->grp[1]), fdbl(8000), fdbl(-1000));
  	GroupFarm(&(w->grp[2]), fdbl(6000), fdbl(2000));
  	GroupFarm(&(w->grp[3]), fdbl(1000), fdbl(6000));
  	GroupFarm(&(w->grp[4]), fdbl(6000), fdbl(10000));
  	GroupFarm(&(w->grp[5]), fdbl(4000), fdbl(14000));
  	GroupFarm(&(w->grp[6]), fdbl(11000), fdbl(1000));
  	GroupFarm(&(w->grp[7]), fdbl(-3000), fdbl(000));
  	GroupFarm(&(w->grp[8]), fdbl(4000), fdbl(-1000));
    
    fgt[0].state=-9; fgt[0].role=1; fgt[0].tgn=-1;// big airplane
    fgt[0].tx = fdbl(-10000); fgt[0].ty = fdbl(0); fgt[0].tz = fdbl(19000); 
    fgt[0].ax = fdbl(10015); fgt[0].ay = fdbl(2); fgt[0].az = fdbl(-2020); 
    fgt[0].type=1; fgt[0].timetogo = TimGetTicks() + 6000;
    /*fgt[0].state=-9; fgt[0].role=5; fgt[0].tgn=-1;// big airplane
    fgt[0].tx = fdbl(10000); fgt[0].ty = fdbl(0); fgt[0].tz = fdbl(1000);
    fgt[0].ax = fdbl(10015); fgt[0].ay = fdbl(2); fgt[0].az = fdbl(-2020);
    fgt[0].type=1; fgt[0].timetogo = TimGetTicks() + 6000;*/
    fgt[0].vx = fdbl(0); fgt[0].vy = 25; fgt[0].vz = fdbl(1);    fgt[0].Kurs = fdbl(0);
    
    fgt[1].state=4; fgt[1].role=0; fgt[1].tgn=-1; // att user
    fgt[1].ax = fdbl(11500); fgt[1].ay = fdbl(300); fgt[1].az = fdbl(7000); 
    
    fgt[2].state=4; fgt[2].role=0; fgt[2].tgn=-1; 
    fgt[2].ax = fdbl(12500); fgt[2].ay = fdbl(100); fgt[2].az = fdbl(8000); 
    
    fgt[3].state=4; fgt[3].role=0; fgt[3].tgn=-1; // att 
    fgt[3].ax = fdbl(8000); fgt[3].ay = fdbl(100); fgt[3].az = fdbl(7000); 
    
    fgt[4].state=6; fgt[4].role=4; fgt[4].tgn=0; // att pl
    fgt[4].ax = fdbl(4000); fgt[4].ay = fdbl(100); fgt[4].az = fdbl(14000); 
    
    fgt[5].state=4; fgt[5].role=0; fgt[5].tgn=-1; // att 
    fgt[5].ax = fdbl(1000); fgt[5].ay = fdbl(100); fgt[5].az = fdbl(19000); 
    
    fgt[6].state=6; fgt[6].role=4; fgt[6].tgn=0; // att pl
    fgt[6].ax = fdbl(-2500); fgt[6].ay = fdbl(100); fgt[6].az = fdbl(23000); 
    
    fgt[7].state=6; fgt[7].role=4; fgt[7].tgn=0; // att pl
    fgt[7].ax = fdbl(-5500); fgt[7].ay = fdbl(100); fgt[7].az = fdbl(23000); 
	
	nfgt = 8;    
}

void MissionZrk4(World *w) WSEC;
void MissionZrk4(World *w)
{
	if (fgt[0].state==0) {
 		SetText("Mission failed.");
   		failed=1;
   	}
   	if (fgt[0].ax < fdbl(-7000) || fgt[0].az > fdbl(16000)) {
    	SetText("Mission complete!");
     	mcomplete=1;
    }
}

void MissionAct4(World *w, UInt32 tick) WSEC;
void MissionAct4(World *w, UInt32 tick)
{
	Int32 ang;
 	dbl dx,dy;
        if (w->grp[1].visible) { // rotate radar
        	dbl X=fdbl(8000+2),Z=fdbl(-1000+5);
        	ang = tick%360; 
         	while(ang<0) ang+=360;
         	dx = fmul(cosa[ang],fdbl(10));
          	dy = fmul(sina[ang],fdbl(10));
            if (w->grp[1].visible && w->grp[1].nobj>1) { //our
	           	w->grp[1].obj[2].dots[0].ax=X-dx; w->grp[1].obj[2].dots[0].az=Z-dy;
    	       	w->grp[1].obj[2].dots[3].ax=X-dx; w->grp[1].obj[2].dots[3].az=Z-dy;
        	   	w->grp[1].obj[2].dots[1].ax=X+dx; w->grp[1].obj[2].dots[1].az=Z+dy;
           		w->grp[1].obj[2].dots[2].ax=X+dx; w->grp[1].obj[2].dots[2].az=Z+dy;
             }
        }
}

void MissionDestroy4(Int16 tgn) WSEC;
void MissionDestroy4(Int16 tgn)
{
  switch(tgn) {
     case 1:SetText("Our radar is destroyed.");
     break;
    }
}

void MissionMap4(World *w) WSEC;
void MissionMap4(World *w)
{
	EventType e;
 	Int32 x,y, cx,cy, fcx[16], fcy[16], i, rd;
  	Char capt[]="ARFFFFFFF";
 
  	if (w->grp[1].nobj>1) rd=1;
   	else rd=0;
	WinEraseWindow();
 	for(x=0; x<w->ngrp; x++)
		WinDrawChars(&(capt[x]), 1, fint(w->grp[x].cx)/125+54, 122- fint(w->grp[x].cz)/125); 	
 
 	WinDrawChars("A-Airbase, F-Farm", 17, 2, 140);
 	WinDrawChars("R-Radar", 7, 2, 150);
	
    
    for(x=32;x<160;x++) {
        if (x&2) continue;
        WinDrawPixel(x,x-32);
    }
    
    cx = fint(mx)/125+56; cy = 128- fint(mz)/125;
    x = fint(fmul(sina[fint(mKurs)],fdbl(5)));     y = fint(fmul(-cosa[fint(mKurs)],fdbl(5)));
	for(i=0;i<nfgt;i++) {
	    fcx[i] = fint(fgt[i].ax)/125+56; fcy[i] = 128- fint(fgt[i].az)/125;
    }    

 	if (rd){
      for(i=0;i<nfgt;i++)
      	if (fgt[i].state>0 && fcx[i]>=0 && fcx[i]<160 && fcy[i]>=0 && fcy[i]<160) {
	      WinInvertLine(fcx[i],fcy[i],fcx[i]+1,fcy[i]);
	      WinInvertLine(fcx[i],fcy[i]+1,fcx[i]+1,fcy[i]+1);
        }
    } else
        WinDrawChars("No radar info!", 14, 2, 1);
 do {
      EvtGetEvent (&e, 40);
      if (cx>=0 && cx<160 && cy>=0 && cy<160) {
	      WinInvertLine(cx,cy,cx+x,cy+y);
       	  WinInvertLine(cx+y/2, cy-x/2, cx-y/2, cy+x/2);
      }
      if (rd)
      for(i=0;i<nfgt;i++)
      	if (fgt[i].state>0 && fcx[i]>=0 && fcx[i]<160 && fcy[i]>=0 && fcy[i]<160) {
	      WinInvertLine(fcx[i],fcy[i],fcx[i]+1,fcy[i]);
	      WinInvertLine(fcx[i],fcy[i]+1,fcx[i]+1,fcy[i]+1);
        }
      //SysHandleEvent (&e);
    } while (e.eType!=keyDownEvent && e.eType!=penDownEvent);
}

void MissionBrief4(World *w) WSEC2;
void MissionBrief4(World *w)
{
	Char *s;
 	RectangleType rc;
  	Int16 done=0;
   	EventType e;
 	WinEraseWindow();
	WinDrawChars("MISSION BRIEFING",16,30,0);
	s = "A liner with our high command";
 	WinDrawChars(s, StrLen(s), 5, 10);
	s = "is going to take off from our";
 	WinDrawChars(s, StrLen(s), 5, 20); 
	s = "airbase and go north-west.";
 	WinDrawChars(s, StrLen(s), 5, 30); 
	s = "It's route passes near the front";
 	WinDrawChars(s, StrLen(s), 5, 40); 
	s = "and the enemy will try to destroy";
 	WinDrawChars(s, StrLen(s), 5, 50); 
	s = "the liner. Your mission is to";
 	WinDrawChars(s, StrLen(s), 5, 60); 
	s = "protect the liner and kill";
 	WinDrawChars(s, StrLen(s), 5, 70); 
	s = "attackers.";
 	WinDrawChars(s, StrLen(s), 5, 80); 

    rc.topLeft.x=120; rc.topLeft.y=140;
    rc.extent.x=20; rc.extent.y=15;
  	WinDrawRectangle(&rc,5);
   	WinEraseChars("Go",2,123,142);
    
    rc.topLeft.x=30; rc.topLeft.y=140;
    rc.extent.x=25; rc.extent.y=15;
  	WinDrawRectangle(&rc,5);
   	WinEraseChars("Map",3,33,142);
    
    do {
      EvtGetEvent (&e, evtWaitForever);
      //SysHandleEvent (&e);
	  if (e.eType == penDownEvent && e.screenY >140 && e.screenY <152 && e.screenX>120) done=1;
   	  if (e.eType == penDownEvent && e.screenY >140 && e.screenY <152 && e.screenX<80) {
      	MissionMap4(w);
       	MissionBrief4(w);
        done=1;
      }
    } while (!done);
}

