void MissionInit8(World *w) WSEC;
void MissionInit8(World *w)
{
	dbl X,Z;
 	UInt32 n,f,t,i,s;

  	clrGround = clrSand;
	WorldCreate(w, 9);

    t = TimGetTicks()*0xDADDEE; s=84;
    for(n=0;n<9;n++) {
        do {
	        X = bitrand(t + s*0xBADBEE)%fdbl(10000)+fdbl(3000);
    	    Z = bitrand(t + s*0xDEBABA)%fdbl(10000)+fdbl(6000);
         	s++;
        	f=0;
	        for(i=0;i<n;i++)
	        	if (Abs(X-w->grp[i].cx)<fdbl(2000) && Abs(Z-w->grp[i].cz)<fdbl(2000)) f=1;
	    } while(f);
	  	GroupFarm(&(w->grp[n]), X, Z);
    }
    
    
  	basex1 = fdbl(10); basex2 = fdbl(20);
  	basez1 = fdbl(-40); basez2 = fdbl(160);
    mx=fdbl(15); my=fdbl(120); mz=fdbl(-20); mSpeed = fdbl(100); maSpeed=fdbl(100);
    mKurs=0; mKren=0; mTang=0; 
  
  	ebasex = fdbl(12000); ebasez = fdbl(6000);

   	for(n=0;n<16;n++) {
	    X = bitrand(t + n*0xBEEFFADE)%fdbl(10000)+fdbl(3000);
    	Z = bitrand(t + (n+20)*0xFADEBABA)%fdbl(10000)+fdbl(6000);
	    fgt[n].state=2; fgt[n].role=n&1; fgt[n].tgn=-1;// attack user
    	fgt[n].tx = X + fdbl(500); fgt[n].ty = fdbl(0); fgt[n].tz = Z; 
	    fgt[n].ax = X; fgt[n].ay = fdbl(200); fgt[n].az = Z; 
    }
	nfgt = 16;    
 
   	for(n=0;n<30;n++) {
	    X = bitrand(t + n*0xBECFFCDE)%fdbl(10000)+fdbl(3000);
    	Z = bitrand(t + (n+20)*0xFAEEBCBF)%fdbl(10000)+fdbl(6000);
    	LauncherSet(&(lns[n]), X, Z);
    }
    nlns=30;
    rocketsleft=25; maSpeed=fdbl(100);  wmaSpeed=fdbl(100);
}

void MissionZrk8(World *w) WSEC;
void MissionZrk8(World *w)
{
	Int16 x,f=0;
 	for(x=0;x<nfgt;x++)
  		if (fgt[x].state>0) f=1;
    if (!f) {
    	SetText("Mission complete!");
     	mcomplete=1;
    }
}

void MissionAct8(World *w, UInt32 tick) WSEC;
void MissionAct8(World *w, UInt32 tick)
{
}

void MissionDestroy8(Int16 tgn) WSEC;
void MissionDestroy8(Int16 tgn)
{
}

void MissionMap8(World *w) WSEC;
void MissionMap8(World *w)
{
	EventType e;
 	Int32 x,y, cx,cy, fcx[16], fcy[16], i, rd;
  	Char capt[]="FFFFFFFFF";
 
	rd=1;
	WinEraseWindow();
 	for(x=0; x<w->ngrp; x++)
		WinDrawChars(&(capt[x]), 1, fint(w->grp[x].cx)/125+54, 122- fint(w->grp[x].cz)/125); 	
 
 	WinDrawChars("F-Farm", 6, 2, 150);
    
    cx = fint(mx)/125+56; cy = 128- fint(mz)/125;
    x = fint(fmul(sina[fint(mKurs)],fdbl(5)));     y = fint(fmul(-cosa[fint(mKurs)],fdbl(5)));
	for(i=0;i<nfgt;i++) {
	    fcx[i] = fint(fgt[i].ax)/125+56; fcy[i] = 128- fint(fgt[i].az)/125;
    }    

 	if (rd){
      for(i=0;i<nfgt;i++)
      	if (fgt[i].state>0 && fcx[i]>=0 && fcx[i]<160 && fcy[i]>=0 && fcy[i]<160) {
	      WinInvertLine(fcx[i],fcy[i],fcx[i]+1,fcy[i]);
	      WinInvertLine(fcx[i],fcy[i]+1,fcx[i]+1,fcy[i]+1);
        }
    } else
        WinDrawChars("No radar info!", 14, 2, 1);
 do {
      EvtGetEvent (&e, 40);
      if (cx>=0 && cx<160 && cy>=0 && cy<160) {
	      WinInvertLine(cx,cy,cx+x,cy+y);
       	  WinInvertLine(cx+y/2, cy-x/2, cx-y/2, cy+x/2);
      }
      if (rd)
      for(i=0;i<nfgt;i++)
      	if (fgt[i].state>0 && fcx[i]>=0 && fcx[i]<160 && fcy[i]>=0 && fcy[i]<160) {
	      WinInvertLine(fcx[i],fcy[i],fcx[i]+1,fcy[i]);
	      WinInvertLine(fcx[i],fcy[i]+1,fcx[i]+1,fcy[i]+1);
        }
    } while (e.eType!=keyDownEvent && e.eType!=penDownEvent);
}

void MissionBrief8(World *w) WSEC2;
void MissionBrief8(World *w)
{
	Char *s;
 	RectangleType rc;
  	Int16 done=0;
   	EventType e;
 	WinEraseWindow();
	WinDrawChars("MISSION BRIEFING",16,30,0);
	s = "This is an always-new mission";
 	WinDrawChars(s, StrLen(s), 5, 10);
	s = "with randomly generated maps and";
 	WinDrawChars(s, StrLen(s), 5, 20); 
	s = "sets of enemy fighters and men";
 	WinDrawChars(s, StrLen(s), 5, 30); 
	s = "with rocket launchers. Just pure";
 	WinDrawChars(s, StrLen(s), 5, 40); 
	s = "action, destroy as many";
 	WinDrawChars(s, StrLen(s), 5, 50); 
	s = "enemies as possible.";
 	WinDrawChars(s, StrLen(s), 5, 60); 

    rc.topLeft.x=120; rc.topLeft.y=140;
    rc.extent.x=20; rc.extent.y=15;
  	WinDrawRectangle(&rc,5);
   	WinEraseChars("Go",2,123,142);
    
    rc.topLeft.x=30; rc.topLeft.y=140;
    rc.extent.x=25; rc.extent.y=15;
  	WinDrawRectangle(&rc,5);
   	WinEraseChars("Map",3,33,142);
    
    do {
      EvtGetEvent (&e, evtWaitForever);
      //SysHandleEvent (&e);
	  if (e.eType == penDownEvent && e.screenY >140 && e.screenY <152 && e.screenX>120) done=1;
   	  if (e.eType == penDownEvent && e.screenY >140 && e.screenY <152 && e.screenX<80) {
      	MissionMap8(w);
       	MissionBrief8(w);
        done=1;
      }
    } while (!done);
}

