void MissionInit9(World *w) WSEC;
void MissionInit9(World *w)
{
	dbl X,Z;

 	clrGround = clrSand;
	WorldCreate(w, 6);
    //our airbase
 	X=fdbl(3000); Z=fdbl(1000);
 	GroupCreate(&(w->grp[0]),4);
    w->grp[0].cx = fdbl(-5)+X; w->grp[0].cy=0; w->grp[0].cz=fdbl(60)+Z; w->grp[0].R=fdbl(110);
    ObjectCube(&(w->grp[0].obj[3]),fdbl(40)+X,fdbl(0),fdbl(0)+Z,  fdbl(10),fdbl(10),fdbl(30));
	ObjectCube(&(w->grp[0].obj[1]), fdbl(40)+X, fdbl(0), fdbl(120)+Z,  fdbl(10), fdbl(10), fdbl(30));
	ObjectCube(&(w->grp[0].obj[2]), fdbl(-20)+X, fdbl(0), fdbl(60)+Z,  fdbl(10), fdbl(10), fdbl(30));
 	ObjectSquare(&(w->grp[0].obj[0]), fdbl(10)+X, fdbl(-40)+Z, fdbl(10), fdbl(200), clrConcrete);
    
  	basex1 = X+fdbl(10); basex2 = X+fdbl(20);
  	basez1 = Z+fdbl(-40); basez2 = Z+fdbl(160);
    mx=fdbl(15)+X; my=fdbl(2); mz=fdbl(-20)+Z; mSpeed = fdbl(0); maSpeed=fdbl(0);
    mKurs=0; mKren=0; mTang=0; 

   	// enemy airbase
 	X=fdbl(3000); Z=fdbl(14000);
 	GroupCreate(&(w->grp[1]),5);
    w->grp[1].cx = fdbl(-5)+X; w->grp[1].cy=0; w->grp[1].cz=fdbl(60)+Z; w->grp[1].R=fdbl(110);
    ObjectCube(&(w->grp[1].obj[3]),fdbl(40)+X,fdbl(0),fdbl(0)+Z,  fdbl(10),fdbl(10),fdbl(30));
	ObjectCube(&(w->grp[1].obj[1]), fdbl(40)+X, fdbl(0), fdbl(120)+Z,  fdbl(10), fdbl(10), fdbl(30));
	ObjectCube(&(w->grp[1].obj[2]), fdbl(-20)+X, fdbl(0), fdbl(120)+Z,  fdbl(10), fdbl(10), fdbl(30));
    ObjectCube(&(w->grp[1].obj[4]),fdbl(-20)+X,fdbl(0),fdbl(0)+Z,  fdbl(10),fdbl(10),fdbl(30));
 	ObjectSquare(&(w->grp[1].obj[0]), fdbl(10)+X, fdbl(-40)+Z, fdbl(10), fdbl(200), clrConcrete);
  	ebasex = fdbl(3010); ebasez = fdbl(14000);
   
	GroupRadar(&(w->grp[2]), fdbl(-1000), fdbl(10000)); w->grp[2].lockable=1;
 	GroupZrk(&(w->grp[3]), fdbl(1000), fdbl(14000));
 	GroupZrk(&(w->grp[4]), fdbl(5000), fdbl(14000));
 	GroupZrk(&(w->grp[5]), fdbl(5000), fdbl(10000));
     
    fgt[0].state=-9; fgt[0].role=5; fgt[0].tgn=-1;// big airplane with troops
    fgt[0].tx = fdbl(3000); fgt[0].ty = fdbl(0); fgt[0].tz = fdbl(14000); 
    fgt[0].ax = fdbl(3015); fgt[0].ay = fdbl(2); fgt[0].az = fdbl(1000-20); 
    fgt[0].type=1; fgt[0].timetogo = TimGetTicks() + 7000;
    fgt[0].vx = fdbl(0); fgt[0].vy = 25; fgt[0].vz = fdbl(1);    fgt[0].Kurs = fdbl(0);
    
	nfgt = 6;    
 	Z = TimGetTicks();
	for(X=1;X<nfgt;X++) {
	 	fgt[X].state=-9; fgt[X].role=0; fgt[X].tgn=-1; // att usr
    	fgt[X].tx = fdbl(3000); fgt[X].ty = fdbl(0); fgt[X].tz = fdbl(13000); 
      	fgt[X].ax = ebasex; fgt[X].az = ebasez;  fgt[X].timetogo = Z + X*2000;
    }
    LauncherSet(&(lns[0]), fdbl(3050)+fdbl(1500), fdbl(12050)+fdbl(1500));
    LauncherSet(&(lns[1]), fdbl(3050)-fdbl(1500), fdbl(12050)+fdbl(1500));
    LauncherSet(&(lns[2]), fdbl(3050)+fdbl(1500), fdbl(12050)-fdbl(1500));
    LauncherSet(&(lns[3]), fdbl(3050)-fdbl(1500), fdbl(12050)-fdbl(1500));
    LauncherSet(&(lns[4]), fdbl(3050)+fdbl(3000), fdbl(12050)+fdbl(3000));
    LauncherSet(&(lns[5]), fdbl(3050)-fdbl(3000), fdbl(12050)+fdbl(3000));
    LauncherSet(&(lns[6]), fdbl(3050)+fdbl(3000), fdbl(12050)-fdbl(3000));
    LauncherSet(&(lns[7]), fdbl(3050)-fdbl(3000), fdbl(12050)-fdbl(3000));
    nlns=8;
    
}

void MissionZrk9(World *w) WSEC;
void MissionZrk9(World *w)
{
	Int32 x,y;
     
 	if (w->grp[2].nobj>1) {
  	
   	if (viewstate<90 && !danger && w->grp[3].nobj>1 && my>fdbl(20)) {
   	   	x = fint(mx)-1000; y = fint(mz) - 14000;
       	x = isqrt(x*x + y*y);
       	if (x<5000 && my>fdbl(20)) { // fire ZRK
          	RocketSend(7,-1,fdbl(1000),fdbl(10),fdbl(14000));
        }
    }
	if (w->grp[3].nobj>1) {    
       	x = fint(fgt[0].ax)-1000; y = fint(fgt[0].az) - 14000;
       	x = isqrt(x*x + y*y);
       	if (x<5000) { // fire ZRK
          	RocketSend(10,-1,fdbl(1000),fdbl(10),fdbl(14000));
        }
    }  	
  	if (viewstate<90 && !danger && w->grp[4].nobj>1 && my>fdbl(20)) {
       	x = fint(mx)-5000; y = fint(mz) - 14000;
       	x = isqrt(x*x + y*y);
       	if (x<5000 && my>fdbl(20)) { // fire ZRK
          	RocketSend(7,-1,fdbl(5000),fdbl(10),fdbl(14000));
        }
	}
    if (w->grp[4].nobj>1) {        
       	x = fint(fgt[0].ax)-5000; y = fint(fgt[0].az) - 14000;
       	x = isqrt(x*x + y*y);
       	if (x<5000) { // fire ZRK
          	RocketSend(10,-1,fdbl(5000),fdbl(10),fdbl(14000));
        }
    }  	
  	if (viewstate<90 && !danger && w->grp[5].nobj>1 && my>fdbl(20)) {
       	x = fint(mx)-5000; y = fint(mz) - 10000;
       	x = isqrt(x*x + y*y);
       	if (x<5000 && my>fdbl(20)) { // fire ZRK
          	RocketSend(7,-1,fdbl(5000),fdbl(10),fdbl(10000));
        }
    }
    if (w->grp[5].nobj>1) {
       	x = fint(fgt[0].ax)-5000; y = fint(fgt[0].az) - 10000;
       	x = isqrt(x*x + y*y);
       	if (x<5000) { // fire ZRK
          	RocketSend(10,-1,fdbl(5000),fdbl(10),fdbl(10000));
        }
    }  	
    } // radar 
   	if (fgt[0].state==0 && !troopsout) {
    	SetText("Mission failed!");
     	failed=1;
     }
    if (troopsout) {
	   	SetText("Mission complete!");
     	mcomplete=1;
    }
}

void MissionAct9(World *w, UInt32 tick) WSEC;
void MissionAct9(World *w, UInt32 tick)
{
	Int32 ang;
 	dbl dx,dy;
  
        if (w->grp[2].visible && w->grp[2].nobj>1) { // rotate radar
        	dbl X=fdbl(-1000+2),Z=fdbl(10005);
        	ang = tick%360; 
         	while(ang<0) ang+=360;
         	dx = fmul(cosa[ang],fdbl(10));
          	dy = fmul(sina[ang],fdbl(10));
            if (w->grp[2].visible && w->grp[2].nobj>1) { 
	           	w->grp[2].obj[2].dots[0].ax=X-dx; w->grp[2].obj[2].dots[0].az=Z-dy;
    	       	w->grp[2].obj[2].dots[3].ax=X-dx; w->grp[2].obj[2].dots[3].az=Z-dy;
        	   	w->grp[2].obj[2].dots[1].ax=X+dx; w->grp[2].obj[2].dots[1].az=Z+dy;
           		w->grp[2].obj[2].dots[2].ax=X+dx; w->grp[2].obj[2].dots[2].az=Z+dy;
             }
        }
}

void MissionDestroy9(Int16 tgn) WSEC;
void MissionDestroy9(Int16 tgn)
{
  switch(tgn) {
     case 2:SetText("Radar is destroyed!");
     break;
     case 3:
     case 4:
     case 5:SetText("ZRK is destroyed!");
     break;
    }
}

void MissionMap9(World *w) WSEC;
void MissionMap9(World *w)
{
	EventType e;
 	Int32 x,y, cx,cy, fcx[16], fcy[16], i, rd;
  	Char capt[]="AARZZZFFFF";
 
  	rd=1;
   	
	WinEraseWindow();
 	for(x=0; x<w->ngrp; x++)
		WinDrawChars(&(capt[x]), 1, fint(w->grp[x].cx)/125+54, 122- fint(w->grp[x].cz)/125); 	
 
 	WinDrawChars("A-Airbase, F-Farm", 17, 2, 140);
 	WinDrawChars("R-Radar, Z-ZRK", 7, 2, 150);
	
    for(x=0;x<160;x++) {
        if (x&2) continue;
        WinDrawPixel(x,100);
    }

 	cx = fint(w->grp[3].cx)/125+56; cy = 128- fint(w->grp[3].cz)/125;
 	for(x=0;x<36;x++)
  		WinDrawPixel(cx + fint(fmul(cosa[x*10],fdbl(40))), cy + fint(fmul(sina[x*10],fdbl(40))));
 	cx = fint(w->grp[4].cx)/125+56; cy = 128- fint(w->grp[4].cz)/125;
 	for(x=0;x<36;x++)
  		WinDrawPixel(cx + fint(fmul(cosa[x*10],fdbl(40))), cy + fint(fmul(sina[x*10],fdbl(40))));
 	cx = fint(w->grp[5].cx)/125+56; cy = 128- fint(w->grp[5].cz)/125;
 	for(x=0;x<36;x++)
  		WinDrawPixel(cx + fint(fmul(cosa[x*10],fdbl(40))), cy + fint(fmul(sina[x*10],fdbl(40))));
        
    
    cx = fint(mx)/125+56; cy = 128- fint(mz)/125;
    x = fint(fmul(sina[fint(mKurs)],fdbl(5)));     y = fint(fmul(-cosa[fint(mKurs)],fdbl(5)));
	for(i=0;i<nfgt;i++) {
	    fcx[i] = fint(fgt[i].ax)/125+56; fcy[i] = 128- fint(fgt[i].az)/125;
    }    

 	if (rd){
      for(i=0;i<nfgt;i++)
      	if (fgt[i].state>0 && fcx[i]>=0 && fcx[i]<160 && fcy[i]>=0 && fcy[i]<160) {
	      WinInvertLine(fcx[i],fcy[i],fcx[i]+1,fcy[i]);
	      WinInvertLine(fcx[i],fcy[i]+1,fcx[i]+1,fcy[i]+1);
        }
    } else
        WinDrawChars("No radar info!", 14, 2, 1);
 do {
      EvtGetEvent (&e, 40);
      if (cx>=0 && cx<160 && cy>=0 && cy<160) {
	      WinInvertLine(cx,cy,cx+x,cy+y);
       	  WinInvertLine(cx+y/2, cy-x/2, cx-y/2, cy+x/2);
      }
      if (rd)
      for(i=0;i<nfgt;i++)
      	if (fgt[i].state>0 && fcx[i]>=0 && fcx[i]<160 && fcy[i]>=0 && fcy[i]<160) {
	      WinInvertLine(fcx[i],fcy[i],fcx[i]+1,fcy[i]);
	      WinInvertLine(fcx[i],fcy[i]+1,fcx[i]+1,fcy[i]+1);
        }
      //SysHandleEvent (&e);
    } while (e.eType!=keyDownEvent && e.eType!=penDownEvent);
}

void MissionBrief9(World *w) WSEC2;
void MissionBrief9(World *w)
{
	Char *s;
 	RectangleType rc;
  	Int16 done=0;
   	EventType e;
 	WinEraseWindow();
	WinDrawChars("MISSION BRIEFING",16,30,0);
	s = "We're performing a landing";
 	WinDrawChars(s, StrLen(s), 5, 10);
	s = "operation to the enemy airbase. The";
 	WinDrawChars(s, StrLen(s), 5, 20); 
	s = "enemy has a good anti-air defence";
 	WinDrawChars(s, StrLen(s), 5, 30); 
	s = "and your task is protect our";
 	WinDrawChars(s, StrLen(s), 5, 40); 
	s = "liner from ZRKs by destroying";
 	WinDrawChars(s, StrLen(s), 5, 50); 
	s = "ZRKs or enemy radar. This kind";
 	WinDrawChars(s, StrLen(s), 5, 60); 
	s = "of radar doesn't see you when";
 	WinDrawChars(s, StrLen(s), 5, 70); 
	s = "your altitude is below 20 meters.";
 	WinDrawChars(s, StrLen(s), 5, 80); 

    rc.topLeft.x=120; rc.topLeft.y=140;
    rc.extent.x=20; rc.extent.y=15;
  	WinDrawRectangle(&rc,5);
   	WinEraseChars("Go",2,123,142);
    
    rc.topLeft.x=30; rc.topLeft.y=140;
    rc.extent.x=25; rc.extent.y=15;
  	WinDrawRectangle(&rc,5);
   	WinEraseChars("Map",3,33,142);
    
    do {
      EvtGetEvent (&e, evtWaitForever);
      //SysHandleEvent (&e);
	  if (e.eType == penDownEvent && e.screenY >140 && e.screenY <152 && e.screenX>120) done=1;
   	  if (e.eType == penDownEvent && e.screenY >140 && e.screenY <152 && e.screenX<80) {
      	MissionMap9(w);
       	MissionBrief9(w);
        done=1;
      }
    } while (!done);
}
