UInt8
diCube0[] = {0,1,5,4},
diCube1[] = {1,3,7,5},
diCube2[] = {2,3,7,6},
diCube3[] = {0,2,6,4},
diCube4[] = {0,1,3,2},
diCube5[] = {4,5,7,6};

void ObjectCube(Object *cube, dbl x, dbl y, dbl z, dbl sx, dbl sy, dbl sz) GFX;
void ObjectCube(Object *cube, dbl x, dbl y, dbl z, dbl sx, dbl sy, dbl sz)
{
    ObjectCreate(cube,8,12,6);
    cube->polygonal = 1;
    cube->dots[0].ax = x;       cube->dots[0].ay = y;       cube->dots[0].az = z;
    cube->dots[1].ax = x+sx;    cube->dots[1].ay = y;       cube->dots[1].az = z;
    cube->dots[2].ax = x;       cube->dots[2].ay = y+sy;    cube->dots[2].az = z;
    cube->dots[3].ax = x+sx;    cube->dots[3].ay = y+sy;    cube->dots[3].az = z;
    cube->dots[4].ax = x;       cube->dots[4].ay = y;       cube->dots[4].az = z+sz;
    cube->dots[5].ax = x+sx;    cube->dots[5].ay = y;       cube->dots[5].az = z+sz;
    cube->dots[6].ax = x;       cube->dots[6].ay = y+sy;    cube->dots[6].az = z+sz;
    cube->dots[7].ax = x+sx;    cube->dots[7].ay = y+sy;    cube->dots[7].az = z+sz;
    cube->lines[0].n1=0; cube->lines[0].n2=1;
    cube->lines[1].n1=1; cube->lines[1].n2=3;
    cube->lines[2].n1=3; cube->lines[2].n2=2;
    cube->lines[3].n1=2; cube->lines[3].n2=0;
    cube->lines[4].n1=4; cube->lines[4].n2=5;
    cube->lines[5].n1=5; cube->lines[5].n2=7;
    cube->lines[6].n1=7; cube->lines[6].n2=6;
    cube->lines[7].n1=6; cube->lines[7].n2=4;
    cube->lines[8].n1=0; cube->lines[8].n2=4;
    cube->lines[9].n1=1; cube->lines[9].n2=5;
    cube->lines[10].n1=2; cube->lines[10].n2=6;
    cube->lines[11].n1=3; cube->lines[11].n2=7;
    cube->planes[0].nli = 4; cube->planes[0].li[0]=0; cube->planes[0].li[1]=9;
			    cube->planes[0].li[2]=4; cube->planes[0].li[3]=8;
    cube->planes[0].nx=0; cube->planes[0].ny=fdbl(-1); cube->planes[0].nz=0;
    cube->planes[0].color = clrCube0; cube->planes[0].di = diCube0;
    
    cube->planes[1].nli = 4; cube->planes[1].li[0]=1; cube->planes[1].li[1]=11;
			    cube->planes[1].li[2]=5; cube->planes[1].li[3]=9;
    cube->planes[1].nx=fdbl(1); cube->planes[1].ny=0; cube->planes[1].nz=0;
    cube->planes[1].color = clrCube1; cube->planes[1].di = diCube1;

    cube->planes[2].nli = 4; cube->planes[2].li[0]=2; cube->planes[2].li[1]=10;
			    cube->planes[2].li[2]=6; cube->planes[2].li[3]=11;
    cube->planes[2].nx=0; cube->planes[2].ny=fdbl(1); cube->planes[2].nz=0;
    cube->planes[2].color = clrCube2; cube->planes[2].di = diCube2;

    cube->planes[3].nli = 4; cube->planes[3].li[0]=3; cube->planes[3].li[1]=7;
			    cube->planes[3].li[2]=8; cube->planes[3].li[3]=10;
    cube->planes[3].nx=fdbl(-1); cube->planes[3].ny=0; cube->planes[3].nz=0;
    cube->planes[3].color = clrCube1; cube->planes[3].di = diCube3;

    cube->planes[4].nli = 4; cube->planes[4].li[0]=0; cube->planes[4].li[1]=1;
			    cube->planes[4].li[2]=2; cube->planes[4].li[3]=3;
    cube->planes[4].nx=0; cube->planes[4].ny=0; cube->planes[4].nz=fdbl(-1);
    cube->planes[4].color = clrCube0; cube->planes[4].di = diCube4;

    cube->planes[5].nli = 4; cube->planes[5].li[0]=4; cube->planes[5].li[1]=5;
			    cube->planes[5].li[2]=6; cube->planes[5].li[3]=7;
    cube->planes[5].nx=0; cube->planes[5].ny=0; cube->planes[5].nz=fdbl(1);
    cube->planes[5].color = clrCube0; cube->planes[5].di = diCube5;
}

UInt8 diSquare[] = {0,1,2,3};

void ObjectSquare_far(Object *o, dbl x, dbl z, dbl sx, dbl sz, UInt8 color) GFX;
void ObjectSquare_far(Object *o, dbl x, dbl z, dbl sx, dbl sz, UInt8 color)
{
 	ObjectCreate(o, 4,4,1);
	o->polygonal = 1; o->always = 1;
   	o->dots[0].ax = x; o->dots[0].ay = 0; o->dots[0].az = z+sz;
  	o->dots[1].ax = x+sx; o->dots[1].ay = 0; o->dots[1].az = z+sz;
  	o->dots[2].ax = x+sx; o->dots[2].ay = 0; o->dots[2].az = z;
  	o->dots[3].ax = x; o->dots[3].ay = 0; o->dots[3].az = z;
    o->lines[0].n1 = 0; o->lines[0].n2 = 1;
    o->lines[1].n1 = 1; o->lines[1].n2 = 2;
    o->lines[2].n1 = 2; o->lines[2].n2 = 3;
    o->lines[3].n1 = 3; o->lines[3].n2 = 0;
    o->planes[0].nli = 4;
    o->planes[0].li[0]=0; o->planes[0].li[1]=1;
    o->planes[0].li[2]=2; o->planes[0].li[3]=3;
    o->planes[0].nx=0; o->planes[0].ny=fdbl(1); o->planes[0].nz=0;
    o->planes[0].color = color;
    o->planes[0].di = diSquare;
}

void ObjectSquare(Object *o, dbl x, dbl z, dbl sx, dbl sz, UInt8 color) WSEC;
void ObjectSquare(Object *o, dbl x, dbl z, dbl sx, dbl sz, UInt8 color)
{
	ObjectSquare_far(o, x, z, sx, sz, color);
}

void ObjectVSquare(Object *o, dbl x, dbl y, dbl z, dbl sx, dbl sy, UInt8 color) GFX; //used by radar
void ObjectVSquare(Object *o, dbl x, dbl y, dbl z, dbl sx, dbl sy, UInt8 color)
{
 	ObjectCreate(o, 4,4,1);
	o->polygonal = 1; o->always = 1;
  	o->dots[0].ax = x; o->dots[0].ay = y+sy; o->dots[0].az = z;
  	o->dots[1].ax = x+sx; o->dots[1].ay = y+sy; o->dots[1].az = z;
  	o->dots[2].ax = x+sx; o->dots[2].ay = y; o->dots[2].az = z;
  	o->dots[3].ax = x; o->dots[3].ay = y; o->dots[3].az = z;
    o->lines[0].n1 = 0; o->lines[0].n2 = 1;
    o->lines[1].n1 = 1; o->lines[1].n2 = 2;
    o->lines[2].n1 = 2; o->lines[2].n2 = 3;
    o->lines[3].n1 = 3; o->lines[3].n2 = 0;
    o->planes[0].nli = 4;
    o->planes[0].li[0]=0; o->planes[0].li[1]=1;
    o->planes[0].li[2]=2; o->planes[0].li[3]=3;
    o->planes[0].nx=0; o->planes[0].ny=fdbl(1); o->planes[0].nz=0;
    o->planes[0].color = color;
    o->planes[0].di = diSquare;
}

UInt8
	diRocket0[] = {0,1,4},
	diRocket1[] = {1,2,4},
	diRocket2[] = {2,3,4},
	diRocket3[] = {3,0,4};

void ObjectRocket(Object *o, dbl x, dbl z) GFX;
void ObjectRocket(Object *o, dbl x, dbl z)
{
 	ObjectCreate(o, 5, 4, 4);
  	o->polygonal = 1; o->always = 1;
  	o->dots[0].ax=x-fdbl(1); o->dots[0].ay=fdbl(2); o->dots[0].az=z-fdbl(0);
  	o->dots[1].ax=x-fdbl(0); o->dots[1].ay=fdbl(2); o->dots[1].az=z+fdbl(1);
  	o->dots[2].ax=x+fdbl(1); o->dots[2].ay=fdbl(2); o->dots[2].az=z-fdbl(0);
  	o->dots[3].ax=x-fdbl(0); o->dots[3].ay=fdbl(2); o->dots[3].az=z-fdbl(1);
  	o->dots[4].ax=x-fdbl(0); o->dots[4].ay=fdbl(8); o->dots[4].az=z-fdbl(0);
    o->lines[0].n1 = 0; o->lines[0].n2 = 4;
    o->lines[1].n1 = 1; o->lines[1].n2 = 4;
    o->lines[2].n1 = 2; o->lines[2].n2 = 4;
    o->lines[3].n1 = 3; o->lines[3].n2 = 4;
    o->planes[0].color = clrConcrete; o->planes[0].di = diRocket0; o->planes[0].nli = 3;
    o->planes[1].color = clrConcrete0; o->planes[1].di = diRocket1; o->planes[1].nli = 3;
    o->planes[2].color = clrConcrete; o->planes[2].di = diRocket2; o->planes[2].nli = 3;
    o->planes[3].color = clrConcrete0; o->planes[3].di = diRocket3; o->planes[3].nli = 3;
}

UInt8
	diAirplane0[] = {0,1,3},
	diAirplane1[] = {0,1,2},
	diAirplane2[] = {0,2,3},
	diAirplane3[] = {2,4,5},
	diAirplane4[] = {6,7,8},
	diAirplane5[] = {9,10,11};

void ObjectAirplane(Object *o) GFX;
void ObjectAirplane(Object *o)
{
 	ObjectCreate(o, 12, 12, 6);
	o->polygonal = 1; o->always = 1;
  	o->dots[0].ax = 0; o->dots[0].ay = 0; o->dots[0].az = fdbl(10);
  	o->dots[1].ax = fdbl(-1); o->dots[1].ay = fdbl(0); o->dots[1].az = fdbl(0);
  	o->dots[2].ax = fdbl(0); o->dots[2].ay = 384; o->dots[2].az = fdbl(0);
  	o->dots[3].ax = fdbl(1); o->dots[3].ay = fdbl(0); o->dots[3].az = fdbl(0);
   
  	o->dots[4].ax=fdbl(0); o->dots[4].ay=307; o->dots[4].az=fdbl(2);
  	o->dots[5].ax=fdbl(0); o->dots[5].ay=640; o->dots[5].az=fdbl(0);
   
  	o->dots[6].ax=-128; o->dots[6].ay=0; o->dots[6].az=fdbl(5);
  	o->dots[7].ax=fdbl(-5); o->dots[7].ay=0; o->dots[7].az=fdbl(1);
  	o->dots[8].ax=-230; o->dots[8].ay=0; o->dots[8].az=fdbl(1);
  	o->dots[9].ax=128; o->dots[9].ay=0; o->dots[9].az=fdbl(5);
  	o->dots[10].ax=fdbl(5); o->dots[10].ay=0; o->dots[10].az=fdbl(1);
  	o->dots[11].ax=230; o->dots[11].ay=0; o->dots[11].az=fdbl(1);

	o->lines[0].n1 = 0; o->lines[0].n2 = 1;
	o->lines[1].n1 = 0; o->lines[1].n2 = 2;
	o->lines[2].n1 = 0; o->lines[2].n2 = 3;
	o->lines[3].n1 = 1; o->lines[3].n2 = 2;
	o->lines[4].n1 = 2; o->lines[4].n2 = 3;
	o->lines[5].n1 = 3; o->lines[5].n2 = 1;
	o->lines[6].n1 = 4; o->lines[6].n2 = 5;
	o->lines[7].n1 = 5; o->lines[7].n2 = 2;
	o->lines[8].n1 = 6; o->lines[8].n2 = 7;
	o->lines[9].n1 = 7; o->lines[9].n2 = 8;
	o->lines[10].n1 = 9; o->lines[10].n2 = 10;
	o->lines[11].n1 = 10; o->lines[11].n2 = 11;

 	o->planes[0].color = clrFighter; o->planes[0].di = diAirplane0; o->planes[0].nli = 3;
 	o->planes[1].color = clrFighter; o->planes[1].di = diAirplane1; o->planes[1].nli = 3;
 	o->planes[2].color = clrFighter; o->planes[2].di = diAirplane2; o->planes[2].nli = 3;
 	o->planes[3].color = clrFighter; o->planes[3].di = diAirplane3; o->planes[3].nli = 3;
 	o->planes[4].color = clrFighter; o->planes[4].di = diAirplane4; o->planes[4].nli = 3;
 	o->planes[5].color = clrFighter; o->planes[5].di = diAirplane5; o->planes[5].nli = 3;
}

//void ObjectBigAirplane_far(Object *o) GFX;
void ObjectBigAirplane(Object *o)
{
 	ObjectCreate(o, 12, 12, 6);
	o->polygonal = 1;  o->always = 1;
  	o->dots[0].ax = 0; o->dots[0].ay = 0; o->dots[0].az = fdbl(40);
  	o->dots[1].ax = fdbl(-2); o->dots[1].ay = fdbl(0); o->dots[1].az = fdbl(0);
  	o->dots[2].ax = fdbl(0); o->dots[2].ay = fdbl(3); o->dots[2].az = fdbl(0);
  	o->dots[3].ax = fdbl(2); o->dots[3].ay = fdbl(0); o->dots[3].az = fdbl(0);
   
  	o->dots[4].ax=fdbl(0); o->dots[4].ay=691; o->dots[4].az=fdbl(4);
  	o->dots[5].ax=fdbl(0); o->dots[5].ay=fdbl(6); o->dots[5].az=fdbl(0);
   
  	o->dots[6].ax=fdbl(-1); o->dots[6].ay=0; o->dots[6].az=fdbl(20);
  	o->dots[7].ax=fdbl(-20); o->dots[7].ay=0; o->dots[7].az=fdbl(10);
  	o->dots[8].ax=-192; o->dots[8].ay=0; o->dots[8].az=fdbl(15);
  	o->dots[9].ax=fdbl(1); o->dots[9].ay=0; o->dots[9].az=fdbl(20);
  	o->dots[10].ax=fdbl(20); o->dots[10].ay=0; o->dots[10].az=fdbl(10);
  	o->dots[11].ax=192; o->dots[11].ay=0; o->dots[11].az=fdbl(15);

	o->lines[0].n1 = 0; o->lines[0].n2 = 1;
	o->lines[1].n1 = 0; o->lines[1].n2 = 2;
	o->lines[2].n1 = 0; o->lines[2].n2 = 3;
	o->lines[3].n1 = 1; o->lines[3].n2 = 2;
	o->lines[4].n1 = 2; o->lines[4].n2 = 3;
	o->lines[5].n1 = 3; o->lines[5].n2 = 1;
	o->lines[6].n1 = 4; o->lines[6].n2 = 5;
	o->lines[7].n1 = 5; o->lines[7].n2 = 2;
	o->lines[8].n1 = 6; o->lines[8].n2 = 7;
	o->lines[9].n1 = 7; o->lines[9].n2 = 8;
	o->lines[10].n1 = 9; o->lines[10].n2 = 10;
	o->lines[11].n1 = 10; o->lines[11].n2 = 11;

 	o->planes[0].color = clrFighter; o->planes[0].di = diAirplane0; o->planes[0].nli = 3;
 	o->planes[1].color = clrFighter; o->planes[1].di = diAirplane1; o->planes[1].nli = 3;
 	o->planes[2].color = clrFighter; o->planes[2].di = diAirplane2; o->planes[2].nli = 3;
 	o->planes[3].color = clrFighter; o->planes[3].di = diAirplane3; o->planes[3].nli = 3;
 	o->planes[4].color = clrFighter; o->planes[4].di = diAirplane4; o->planes[4].nli = 3;
 	o->planes[5].color = clrFighter; o->planes[5].di = diAirplane5; o->planes[5].nli = 3;
}

/*void ObjectBigAirplane(Object *o) WSEC;
void ObjectBigAirplane(Object *o)
{
	ObjectBigAirplane_far(o);
} */

void ObjectLauncher_far(Object *o) GFX;
void ObjectLauncher_far(Object *o)
{
	ObjectCreate(o, 14,7,0);
 	o->dots[0].ax = 0;  o->dots[0].ay = 0;  o->dots[0].az = 0;
 	o->dots[1].ax = 0;  o->dots[1].ay = 461;   o->dots[1].az = 0;

 	o->dots[2].ax = 50;  o->dots[2].ay = 256;  o->dots[2].az = 0;
 	o->dots[3].ax = 50;  o->dots[3].ay = 512;   o->dots[3].az = 0;
    
 	o->dots[4].ax = 50;  o->dots[4].ay = 256;  o->dots[4].az = 0;
 	o->dots[5].ax = 50;  o->dots[5].ay = 0;   o->dots[5].az = -150;
  
 	o->dots[6].ax = 0;  o->dots[6].ay = 589;  o->dots[6].az = -256;
 	o->dots[7].ax = 0;  o->dots[7].ay = 383;   o->dots[7].az = 200;
 	o->dots[8].ax = 0;  o->dots[8].ay = 599;  o->dots[8].az = -256;
 	o->dots[9].ax = 0;  o->dots[9].ay = 393;   o->dots[9].az = 200;
 	o->dots[10].ax = -5;  o->dots[10].ay = 594;  o->dots[10].az = -256;
 	o->dots[11].ax = -5;  o->dots[11].ay = 389;   o->dots[11].az = 200;
 	o->dots[12].ax = 0;  o->dots[12].ay = 525;  o->dots[12].az = -128;
 	o->dots[13].ax = 0;  o->dots[13].ay = 384;   o->dots[13].az = 0;
  
  	o->lines[0].n1 = 0;  	o->lines[0].n2 = 1;
  	o->lines[1].n1 = 2;  	o->lines[1].n2 = 3;
  	o->lines[2].n1 = 4;  	o->lines[2].n2 = 5;
  	o->lines[3].n1 = 6;  	o->lines[3].n2 = 7;
  	o->lines[4].n1 = 8;  	o->lines[4].n2 = 9;
  	o->lines[5].n1 = 10;  	o->lines[5].n2 = 11;
  	o->lines[6].n1 = 12;  	o->lines[6].n2 = 13;
}

void ObjectLauncher(Object *o) WSEC;
void ObjectLauncher(Object *o)
{
	ObjectLauncher_far(o);
}


UInt8
diTrooper0[] = {9,12},
diTrooper1[] = {5,12},
diTrooper2[] = {10,12},
diTrooper3[] = {11,12},
diTrooper4[] = {13,14},
diTrooper5[] = {0,1,6,5},
diTrooper6[] = {3,4,9,8},
diTrooper7[] = {4,0,5,9},
diTrooper8[] = {1,2,7,6},
diTrooper9[] = {2,3,8,7};

//void ObjectTrooper(Object *o) GFX;
void ObjectTrooper(Object *o)
{
	dbl e=128, E=fdbl(5)/2;
	ObjectCreate(o, 15,20,10);
	
	o->polygonal = 1; o->always = 1;

 	o->dots[0].ax = e;  o->dots[0].ay = fdbl(13);  o->dots[0].az = e;
 	o->dots[1].ax = e*3/2;  o->dots[1].ay = fdbl(13);  o->dots[1].az = -e/2;
 	o->dots[2].ax = 0;  o->dots[2].ay = fdbl(13);  o->dots[2].az = -2*e;
 	o->dots[3].ax = -e*3/2;  o->dots[3].ay = fdbl(13);  o->dots[3].az = -e/2;
 	o->dots[4].ax = -e;  o->dots[4].ay = fdbl(13);  o->dots[4].az = e;
 	
  	o->dots[5].ax = E;  o->dots[5].ay = fdbl(10);  o->dots[5].az = E;
 	o->dots[6].ax = E*3/2;  o->dots[6].ay = fdbl(10);  o->dots[6].az = -E/2;
 	o->dots[7].ax = 0;  o->dots[7].ay = fdbl(10);  o->dots[7].az = -2*E;
 	o->dots[8].ax = -E*3/2;  o->dots[8].ay = fdbl(10);  o->dots[8].az = -E/2;
 	o->dots[9].ax = -E;  o->dots[9].ay = fdbl(10);  o->dots[9].az = E;
  
  	o->dots[10].ax = E;  o->dots[10].ay = fdbl(10);  o->dots[10].az = -E;
 	o->dots[11].ax = -E;  o->dots[11].ay = fdbl(10);  o->dots[11].az = -E;

 	o->dots[12].ax = 0;  o->dots[12].ay = fdbl(0);  o->dots[12].az = -e/2;
 	o->dots[13].ax = 0;  o->dots[13].ay = -128;  o->dots[13].az = -e/2;
 	o->dots[14].ax = 0;  o->dots[14].ay = fdbl(1);  o->dots[14].az = -e/2;
  	 
  	o->lines[0].n1 = 0;  	o->lines[0].n2 = 1;
  	o->lines[1].n1 = 1;  	o->lines[1].n2 = 2;
  	o->lines[2].n1 = 2;  	o->lines[2].n2 = 3;
  	o->lines[3].n1 = 3;  	o->lines[3].n2 = 4;
  	o->lines[4].n1 = 4;  	o->lines[4].n2 = 0;
  	o->lines[5].n1 = 5;  	o->lines[5].n2 = 6;
  	o->lines[6].n1 = 6;  	o->lines[6].n2 = 7;
  	o->lines[7].n1 = 7;  	o->lines[7].n2 = 8;
  	o->lines[8].n1 = 8;  	o->lines[8].n2 = 9;
  	o->lines[9].n1 = 9;  	o->lines[9].n2 = 5;
   
  	o->lines[10].n1 = 0;  	o->lines[10].n2 = 5;
  	o->lines[11].n1 = 1;  	o->lines[11].n2 = 6;
  	o->lines[12].n1 = 2;  	o->lines[12].n2 = 7;
  	o->lines[13].n1 = 3;  	o->lines[13].n2 = 8;
  	o->lines[14].n1 = 4;  	o->lines[14].n2 = 9;
   	
  	o->lines[15].n1 = 9;  	o->lines[15].n2 = 12;   
  	o->lines[16].n1 = 5;  	o->lines[16].n2 = 12;   
  	o->lines[17].n1 = 10;  	o->lines[17].n2 = 12;   
  	o->lines[18].n1 = 11;  	o->lines[18].n2 = 12;   
   
  	o->lines[19].n1 = 13;  	o->lines[19].n2 = 14;

    o->planes[0].nli = 2; o->planes[0].color = clrBlack; o->planes[0].di = diTrooper0;
    o->planes[1].nli = 2; o->planes[1].color = clrBlack; o->planes[1].di = diTrooper1;
    o->planes[2].nli = 2; o->planes[2].color = clrBlack; o->planes[2].di = diTrooper2;
    o->planes[3].nli = 2; o->planes[3].color = clrBlack; o->planes[3].di = diTrooper3;
    o->planes[4].nli = 2; o->planes[4].color = clrBlack; o->planes[4].di = diTrooper4;
   	o->planes[5].nli = 4; o->planes[5].color = clrConcrete0; o->planes[5].di = diTrooper5;
   	o->planes[6].nli = 4; o->planes[6].color = clrConcrete0; o->planes[6].di = diTrooper6;
   	o->planes[7].nli = 4; o->planes[7].color = clrConcrete0; o->planes[7].di = diTrooper7;
   	o->planes[8].nli = 4; o->planes[8].color = clrConcrete; o->planes[8].di = diTrooper8;
   	o->planes[9].nli = 4; o->planes[9].color = clrConcrete; o->planes[9].di = diTrooper9;
}

UInt8
diOcto0[] = {0,1,9,8},
diOcto1[] = {1,2,10,9},
diOcto2[] = {2,3,11,10},
diOcto3[] = {3,4,12,11},
diOcto4[] = {4,5,13,12},
diOcto5[] = {5,6,14,13},
diOcto6[] = {6,7,15,14},
diOcto7[] = {7,0,8,15},
diOcto8[] = {8,9,10,11,12},
diOcto9[] = {12,13,14,15,8};


void ObjectOcto_far(Object *o, dbl x, dbl z, dbl E, dbl H) GFX;
void ObjectOcto_far(Object *o, dbl x, dbl z, dbl E, dbl H)
{
 	ObjectCreate(o, 16, 24, 10);
  	o->polygonal = 1;
  	o->dots[0].ax = -3*E+x; o->dots[0].ay=0; o->dots[0].az=1*E+z;
  	o->dots[1].ax = -1*E+x; o->dots[1].ay=0; o->dots[1].az=3*E+z;
  	o->dots[2].ax =  1*E+x; o->dots[2].ay=0; o->dots[2].az=3*E+z;
  	o->dots[3].ax =  3*E+x; o->dots[3].ay=0; o->dots[3].az=1*E+z;
  	o->dots[4].ax =  3*E+x; o->dots[4].ay=0; o->dots[4].az=-1*E+z;
  	o->dots[5].ax =  1*E+x; o->dots[5].ay=0; o->dots[5].az=-3*E+z;
  	o->dots[6].ax = -1*E+x; o->dots[6].ay=0; o->dots[6].az=-3*E+z;
  	o->dots[7].ax = -3*E+x; o->dots[7].ay=0; o->dots[7].az=-1*E+z;
  	o->dots[8].ax = -3*E+x; o->dots[8].ay=H; o->dots[8].az=1*E+z;
  	o->dots[9].ax = -1*E+x; o->dots[9].ay=H; o->dots[9].az=3*E+z;
  	o->dots[10].ax =  1*E+x; o->dots[10].ay=H; o->dots[10].az=3*E+z;
  	o->dots[11].ax =  3*E+x; o->dots[11].ay=H; o->dots[11].az=1*E+z;
  	o->dots[12].ax =  3*E+x; o->dots[12].ay=H; o->dots[12].az=-1*E+z;
  	o->dots[13].ax =  1*E+x; o->dots[13].ay=H; o->dots[13].az=-3*E+z;
  	o->dots[14].ax = -1*E+x; o->dots[14].ay=H; o->dots[14].az=-3*E+z;
  	o->dots[15].ax = -3*E+x; o->dots[15].ay=H; o->dots[15].az=-1*E+z;
   	o->lines[0].n1=0; o->lines[0].n2=8;
   	o->lines[1].n1=1; o->lines[1].n2=9;
   	o->lines[2].n1=2; o->lines[2].n2=10;
   	o->lines[3].n1=3; o->lines[3].n2=11;
   	o->lines[4].n1=4; o->lines[4].n2=12;
   	o->lines[5].n1=5; o->lines[5].n2=13;
   	o->lines[6].n1=6; o->lines[6].n2=14;
   	o->lines[7].n1=7; o->lines[7].n2=15;
	o->lines[8].n1=0; o->lines[8].n2=1;
	o->lines[9].n1=1; o->lines[9].n2=2;
	o->lines[10].n1=2; o->lines[10].n2=3;
	o->lines[11].n1=3; o->lines[11].n2=4;
	o->lines[12].n1=4; o->lines[12].n2=5;
	o->lines[13].n1=5; o->lines[13].n2=6;
	o->lines[14].n1=6; o->lines[14].n2=7;
	o->lines[15].n1=7; o->lines[15].n2=0;
 	o->lines[16].n1=8; o->lines[16].n2=9;
 	o->lines[17].n1=9; o->lines[17].n2=10;
 	o->lines[18].n1=10; o->lines[18].n2=11;
 	o->lines[19].n1=11; o->lines[19].n2=12;
 	o->lines[20].n1=12; o->lines[20].n2=13;
 	o->lines[21].n1=13; o->lines[21].n2=14;
 	o->lines[22].n1=14; o->lines[22].n2=15;
 	o->lines[23].n1=15; o->lines[23].n2=8;
  
    o->planes[0].nli = 4; 
    o->planes[0].li[0]=0; o->planes[0].li[1]=1; o->planes[0].li[2]=8; o->planes[0].li[3]=16;
    o->planes[0].nx=fdbl(-1); o->planes[0].ny=0; o->planes[0].nz=fdbl(1);
    o->planes[1].nli = 4; 
    o->planes[1].li[0]=1; o->planes[1].li[1]=2; o->planes[1].li[2]=9; o->planes[1].li[3]=17;
    o->planes[1].nx=fdbl(0); o->planes[1].ny=0; o->planes[1].nz=fdbl(1);
    o->planes[2].nli = 4; 
    o->planes[2].li[0]=2; o->planes[2].li[1]=3; o->planes[2].li[2]=10; o->planes[2].li[3]=18;
    o->planes[2].nx=fdbl(1); o->planes[2].ny=0; o->planes[2].nz=fdbl(1);
    o->planes[3].nli = 4; 
    o->planes[3].li[0]=3; o->planes[3].li[1]=4; o->planes[3].li[2]=11; o->planes[3].li[3]=19;
    o->planes[3].nx=fdbl(1); o->planes[3].ny=0; o->planes[3].nz=fdbl(0);
    o->planes[4].nli = 4; 
    o->planes[4].li[0]=4; o->planes[4].li[1]=5; o->planes[4].li[2]=12; o->planes[4].li[3]=20;
    o->planes[4].nx=fdbl(1); o->planes[4].ny=0; o->planes[4].nz=fdbl(-1);
    o->planes[5].nli = 4; 
    o->planes[5].li[0]=5; o->planes[5].li[1]=6; o->planes[5].li[2]=13; o->planes[5].li[3]=21;
    o->planes[5].nx=fdbl(0); o->planes[5].ny=0; o->planes[5].nz=fdbl(-1);
    o->planes[6].nli = 4; 
    o->planes[6].li[0]=6; o->planes[6].li[1]=7; o->planes[6].li[2]=14; o->planes[6].li[3]=22;
    o->planes[6].nx=fdbl(-1); o->planes[6].ny=0; o->planes[6].nz=fdbl(-1);
    o->planes[7].nli = 4; 
    o->planes[7].li[0]=7; o->planes[7].li[1]=0; o->planes[7].li[2]=15; o->planes[7].li[3]=23;
    o->planes[7].nx=fdbl(-1); o->planes[7].ny=0; o->planes[7].nz=fdbl(0);
#ifdef COLORED
	o->planes[8].nli = 5;
#else
    o->planes[8].nli = 4;
#endif
    o->planes[8].li[0]=16; o->planes[8].li[1]=17; o->planes[8].li[2]=18; o->planes[8].li[3]=19;
    o->planes[8].nx=fdbl(0); o->planes[8].ny=fdbl(1); o->planes[8].nz=fdbl(0);
#ifdef COLORED
	o->planes[9].nli = 5;
#else
    o->planes[9].nli = 4;
#endif
    o->planes[9].li[0]=20; o->planes[9].li[1]=21; o->planes[9].li[2]=22; o->planes[9].li[3]=23;
    o->planes[9].nx=fdbl(0); o->planes[9].ny=fdbl(1); o->planes[9].nz=fdbl(0);

#ifdef COLORED
	o->planes[0].color = clrCube0; o->planes[0].di = diOcto0;	
	o->planes[1].color = clrCube1; o->planes[1].di = diOcto1;	
	o->planes[2].color = clrCube0; o->planes[2].di = diOcto2;	
	o->planes[3].color = clrCube1; o->planes[3].di = diOcto3;	
	o->planes[4].color = clrCube0; o->planes[4].di = diOcto4;	
	o->planes[5].color = clrCube1; o->planes[5].di = diOcto5;	
	o->planes[6].color = clrCube0; o->planes[6].di = diOcto6;	
	o->planes[7].color = clrCube1; o->planes[7].di = diOcto7;	
	o->planes[8].color = clrCube1; o->planes[8].di = diOcto8;	
	o->planes[9].color = clrCube1; o->planes[9].di = diOcto9;	
#endif
}

void ObjectOcto(Object *o, dbl x, dbl z, dbl E, dbl H) WSEC;
void ObjectOcto(Object *o, dbl x, dbl z, dbl E, dbl H)
{
	ObjectOcto_far(o, x, z, E, H);
}

void GroupTruck_far(Group *g, dbl x, dbl z) GFX;
void GroupTruck_far(Group *g, dbl x, dbl z)
{
	UInt8 c0=clrCube0, c1=clrCube1, c2=clrCube2;
 	clrCube0 = clrMilitary0; clrCube1 = clrMilitary1; clrCube2 = clrMilitary1;
	GroupCreate(g, 2);
    g->cx = x; g->cy=0; g->cz=z; g->R=fdbl(50);
	ObjectCube(&(g->obj[0]), x-fdbl(20), 0, z-fdbl(2), fdbl(20), fdbl(4), fdbl(4));
 	g->obj[0].planes[1].nx=fdbl(0); g->obj[0].planes[1].ny=fdbl(-1); g->obj[0].planes[1].nz=0;
	ObjectCube(&(g->obj[1]), x, 0, z-fdbl(2), fdbl(3), fdbl(3), fdbl(4));
 	g->obj[1].planes[3].nx=fdbl(0); g->obj[1].planes[3].ny=fdbl(-1); g->obj[1].planes[3].nz=0;
    g->tx = x; g->ty=1; g->tz=z; g->lockable=1; g->vuln=1;
    clrCube0 = c0; clrCube1 = c1; clrCube2 = c2;
}

void GroupTruck(Group *g, dbl x, dbl z) WSEC;
void GroupTruck(Group *g, dbl x, dbl z)
{
	GroupTruck_far(g, x, z);
}

void GroupFarm_far(Group *g, dbl X, dbl Z) GFX;
void GroupFarm_far(Group *g, dbl X, dbl Z)
{
 	GroupCreate(g,2);
    g->cx = fdbl(125)+X; g->cy=0; g->cz=fdbl(150)+Z; g->R=fdbl(200);
    ObjectSquare(&(g->obj[0]), X-fdbl(30), Z-fdbl(30), fdbl(250), fdbl(300), clrFarm);
    ObjectCube(&(g->obj[1]), X,0,Z, fdbl(10), fdbl(7), fdbl(8));
}

void GroupFarm(Group *g, dbl X, dbl Z) WSEC;
void GroupFarm(Group *g, dbl X, dbl Z)
{
	GroupFarm_far(g, X, Z);
}

void GroupRadar_far(Group *g, dbl X, dbl Z) GFX;
void GroupRadar_far(Group *g, dbl X, dbl Z)
{
	UInt8 c0=clrCube0, c1=clrCube1, c2=clrCube2;
 	clrCube0 = clrMilitary0; clrCube1 = clrMilitary1; clrCube2 = clrMilitary1;
 	GroupCreate(g,3);
    g->cx = fdbl(15)+X; g->cy=fdbl(4); g->cz=fdbl(5)+Z; g->R=fdbl(60);
    ObjectCube(&(g->obj[0]), X,0,Z, fdbl(4), fdbl(4), fdbl(10));
    ObjectCube(&(g->obj[1]), X+fdbl(20),0,Z+fdbl(3), fdbl(10), fdbl(4), fdbl(4));
    ObjectVSquare(&(g->obj[2]), X-fdbl(8), fdbl(4), Z+fdbl(5), fdbl(20), fdbl(8), clrMilitary0);
    g->tx = fdbl(2)+X; g->ty=fdbl(4); g->tz=fdbl(5)+Z; g->vuln=1;
    clrCube0 = c0; clrCube1 = c1; clrCube2 = c2;
}

void GroupRadar(Group *g, dbl X, dbl Z) WSEC;
void GroupRadar(Group *g, dbl X, dbl Z)
{
	GroupRadar_far(g, X, Z);
}

void GroupZrk_far(Group *g, dbl X, dbl Z) GFX;
void GroupZrk_far(Group *g, dbl X, dbl Z)
{
	UInt8 c0=clrCube0, c1=clrCube1, c2=clrCube2;
 	clrCube0 = clrMilitary0; clrCube1 = clrMilitary1; clrCube2 = clrMilitary1;
 	GroupCreate(g,7);
    g->cx = fdbl(15)+X; g->cy=0; g->cz=fdbl(10)+Z; g->R=fdbl(60);
    ObjectCube(&(g->obj[0]), X,0,Z, fdbl(30), fdbl(2), fdbl(20));
    ObjectRocket(&(g->obj[1]), X+fdbl(5), Z+fdbl(5));
    ObjectRocket(&(g->obj[2]), X+fdbl(15), Z+fdbl(5));
    ObjectRocket(&(g->obj[3]), X+fdbl(25), Z+fdbl(5));
    ObjectRocket(&(g->obj[4]), X+fdbl(5), Z+fdbl(15));
    ObjectRocket(&(g->obj[5]), X+fdbl(15), Z+fdbl(15));
    ObjectRocket(&(g->obj[6]), X+fdbl(25), Z+fdbl(15));
    g->tx = fdbl(15)+X; g->ty=1; g->tz=fdbl(10)+Z;  g->vuln=1; g->lockable=1;
    clrCube0 = c0; clrCube1 = c1; clrCube2 = c2;
}

void GroupZrk(Group *g, dbl X, dbl Z) WSEC;
void GroupZrk(Group *g, dbl X, dbl Z)
{
	GroupZrk_far(g, X, Z);
}

void GroupCamp(Group *g, dbl X, dbl Z) GFX;
void GroupCamp(Group *g, dbl X, dbl Z) 
{
	Int16 x;
 	GroupCreate(g,2);
    g->cx = X; g->cy=0; g->cz=Z; g->R=fdbl(30); g->vuln=1;
    ObjectOcto(&(g->obj[0]),X,Z, fdbl(2), fdbl(2));
    g->obj[0].planes[8].ny=fdbl(-1);
    g->obj[0].planes[9].ny=fdbl(-1);
    ObjectOcto(&(g->obj[1]),X,Z, fdbl(2), fdbl(8));
    for(x=0;x<8;x++) {
    	g->obj[1].dots[x].ay = fdbl(2);
     	g->obj[1].planes[x].ny = fdbl(1);
    }
    for(x=8;x<16;x++) {
        g->obj[1].dots[x].ax = X;
        g->obj[1].dots[x].az = Z;
    }
}

#include "mission2.c"
#include "mission8.c"
#include "mission1.c"
#include "mission3.c"
#include "mission4.c"
#include "mission5.c"
#include "mission6.c"
#include "mission7.c"
#include "mission9.c"

//void MakeWorld(World *w) WSEC2;
void MakeWorld(World *w)
{
	clrCube0 = clrConcrete0;
	clrCube1 = clrConcrete;
  	switch(mission) {
       case 2: MissionInit2(w);
       break;
       case 8: MissionInit8(w);
       break;
       case 1: MissionInit1(w);
       break;
       case 3: MissionInit3(w);
       break;
       case 4: MissionInit4(w);
       break;
       case 5: MissionInit5(w);
       break;
       case 6: MissionInit6(w);
       break;
       case 7: MissionInit7(w);
       break;
       case 9: MissionInit9(w);
       break;
    }
}

void MissionZrk(World *w) WSEC;
void MissionZrk(World *w)
{
  	switch(mission) {
       case 2: MissionZrk2(w);
       break;
       case 8: MissionZrk8(w);
       break;
       case 1: MissionZrk1(w);
       break;
       case 3: MissionZrk3(w);
       break;
       case 4: MissionZrk4(w);
       break;
       case 5: MissionZrk5(w);
       break;
       case 6: MissionZrk6(w);
       break;
       case 7: MissionZrk7(w);
       break;
       case 9: MissionZrk9(w);
       break;
    }
}


void MissionAct(World *w, UInt32 tick) WSEC;
void MissionAct(World *w, UInt32 tick)
{
  	switch(mission) {
       case 2: MissionAct2(w, tick);
       break;
       case 8: MissionAct8(w, tick);
       break;
       case 1: MissionAct1(w, tick);
       break;
       case 3: MissionAct3(w, tick);
       break;
       case 4: MissionAct4(w, tick);
       break;
       case 5: MissionAct5(w, tick);
       break;
       case 6: MissionAct6(w, tick);
       break;
       case 7: MissionAct7(w, tick);
       break;
       case 9: MissionAct9(w, tick);
       break;
    }
}

void MissionDestroy(Int16 tgn) WSEC;
void MissionDestroy(Int16 tgn)
{
  	switch(mission) {
       case 2: MissionDestroy2(tgn);
       break;
       case 8: MissionDestroy8(tgn);
       break;
       case 1: MissionDestroy1(tgn);
       break;
       case 3: MissionDestroy3(tgn);
       break;
       case 4: MissionDestroy4(tgn);
       break;
       case 5: MissionDestroy5(tgn);
       break;
       case 6: MissionDestroy6(tgn);
       break;
       case 7: MissionDestroy7(tgn);
       break;
       case 9: MissionDestroy9(tgn);
       break;
    }
}

void ShowMap(World *w) WSEC;
void ShowMap(World *w)
{
	switch(mission) {
    	case 2: MissionMap2(w);
     	break;
    	case 8: MissionMap8(w);
     	break;
    	case 1: MissionMap1(w);
     	break;
    	case 3: MissionMap3(w);
     	break; 
    	case 4: MissionMap4(w);
     	break; 
    	case 5: MissionMap5(w);
     	break; 
    	case 6: MissionMap6(w);
     	break; 
    	case 7: MissionMap7(w);
     	break;
    	case 9: MissionMap9(w);
     	break;
    }
}

void MissionBrief(World *w) WSEC;
void MissionBrief(World *w)
{
	switch(mission) {
     	case 2: MissionBrief2(w);
      	break;
     	case 8: MissionBrief8(w);
      	break;
     	case 1: MissionBrief1(w);
      	break;
     	case 3: MissionBrief3(w);
      	break;
     	case 4: MissionBrief4(w);
      	break;
     	case 5: MissionBrief5(w);
      	break;
     	case 6: MissionBrief6(w);
      	break;
     	case 7: MissionBrief7(w);
      	break;
     	case 9: MissionBrief9(w);
      	break;
    }
}

void MissionScore(World *w) WSEC2;
void MissionScore(World *w)
{
	RectangleType rc;
 	EventType e;
  	Int16 done=0, score=0,x;
   	Char buf[128], *s;
   
	WinEraseWindow();

 	if (mcomplete) score+=1000;
  	if (failed) score-=1000;
   	if (killed) score-=500;
   	for(x=0;x<nfgt;x++)
    	if (fgt[x].state==0)
     		score+=10;
    if (ejected) score /= 2;
 	sprintf(buf,"Your score is %d.",score);
  	
  	WinDrawChars("MISSION RESULTS",15,30,0);
   
   	if (failed) { 
        s = "This mission was a failure.";
    	WinDrawChars(s,StrLen(s),5,20);
    } else 
    if (mcomplete) {
        s = "This mission was a success!";
    	WinDrawChars(s,StrLen(s),5,20);
    } else {
        s = "This mission was incomplete.";
    	WinDrawChars(s,StrLen(s),5,20);
    }
    
    if (ejected) {
        s = "You lost your plane but";
    	WinDrawChars(s,StrLen(s),5,30);
        s = "stayed alive.";
    	WinDrawChars(s,StrLen(s),5,40);
    }
   
   	WinDrawChars(buf,StrLen(buf),5,70);     
  
    rc.topLeft.x=120; rc.topLeft.y=140;
    rc.extent.x=20; rc.extent.y=15;
  	WinDrawRectangle(&rc,5);
   	WinEraseChars("OK",2,123,142);
    do {
      EvtGetEvent (&e, evtWaitForever);
      //SysHandleEvent (&e);
	  if (e.eType == penDownEvent && e.screenY >140 && e.screenY <152 && e.screenX>120) done=1;
    } while (!done);
    
}
