void MissionInit5(World *w) WSEC;
void MissionInit5(World *w)
{
	dbl X,Z;

 	clrGround = clrSand;
	WorldCreate(w, 11);
    //our airbase
 	X=fdbl(-2000); Z=fdbl(2000);
 	GroupCreate(&(w->grp[0]),4);
    w->grp[0].cx = fdbl(-5)+X; w->grp[0].cy=0; w->grp[0].cz=fdbl(60)+Z; w->grp[0].R=fdbl(110);
    ObjectCube(&(w->grp[0].obj[3]),fdbl(-20)+X,fdbl(0),fdbl(0)+Z,  fdbl(10),fdbl(10),fdbl(30));
	ObjectCube(&(w->grp[0].obj[1]), fdbl(40)+X, fdbl(0), fdbl(120)+Z,  fdbl(10), fdbl(10), fdbl(30));
	ObjectCube(&(w->grp[0].obj[2]), fdbl(-20)+X, fdbl(0), fdbl(120)+Z,  fdbl(10), fdbl(10), fdbl(30));
 	ObjectSquare(&(w->grp[0].obj[0]), fdbl(10)+X, fdbl(-40)+Z, fdbl(10), fdbl(200), clrConcrete);
    
  	basex1 = X+fdbl(10); basex2 = X+fdbl(20);
  	basez1 = Z+fdbl(-40); basez2 = Z+fdbl(160);
    mx=fdbl(15)+X; my=fdbl(2); mz=fdbl(-20)+Z; mSpeed = fdbl(1); maSpeed=fdbl(0);
    mKurs=0; mKren=0; mTang=0; 

    //enemy base  
 	X=fdbl(7000); Z=fdbl(12000);
 	GroupCreate(&(w->grp[1]),4);
    w->grp[1].cx = fdbl(15)+X; w->grp[1].cy=0; w->grp[1].cz=fdbl(40)+Z; w->grp[1].R=fdbl(110);
    ObjectCube(&(w->grp[1].obj[0]),fdbl(-20)+X,fdbl(0),fdbl(70)+Z,  fdbl(10),fdbl(7),fdbl(20));
	ObjectCube(&(w->grp[1].obj[1]), fdbl(40)+X, fdbl(0), fdbl(70)+Z,  fdbl(10), fdbl(7), fdbl(20));
	ObjectCube(&(w->grp[1].obj[2]), fdbl(60)+X, fdbl(0), fdbl(70)+Z,  fdbl(10), fdbl(7), fdbl(20));
 	ObjectSquare(&(w->grp[1].obj[3]), fdbl(10)+X, fdbl(-40)+Z, fdbl(10), fdbl(200), clrConcrete);
  	ebasex = fdbl(15+7000); ebasez = fdbl(12000);
  
	GroupRadar(&(w->grp[2]), fdbl(2000), fdbl(12000)); w->grp[2].lockable=1;
 	GroupRadar(&(w->grp[3]), fdbl(9000), fdbl(15000)); w->grp[3].lockable=1;
  	GroupZrk(&(w->grp[4]), fdbl(-2000), fdbl(11000)); w->grp[4].lockable=1;
  	GroupZrk(&(w->grp[5]), fdbl(3000), fdbl(9000)); w->grp[5].lockable=1;
  	GroupZrk(&(w->grp[6]), fdbl(8000), fdbl(11000)); w->grp[6].lockable=1;
  
  	GroupFarm(&(w->grp[7]), fdbl(-2000), fdbl(7000));
  	GroupFarm(&(w->grp[8]), fdbl(5000), fdbl(6000));
  	GroupFarm(&(w->grp[9]), fdbl(0), fdbl(1000));
  	GroupFarm(&(w->grp[10]), fdbl(7000), fdbl(-1000));
    
    fgt[0].state=2; fgt[0].role=1; fgt[0].tgn=-1; //defend
    fgt[0].tx = fdbl(-3000); fgt[0].ty = fdbl(0); fgt[0].tz = fdbl(11000); 
    fgt[0].ax = fdbl(-3700); fgt[0].ay = fdbl(200); fgt[0].az = fdbl(11000); 
    fgt[1].state=2; fgt[1].role=1; fgt[1].tgn=-1;
    fgt[1].tx = fdbl(1700); fgt[1].ty = fdbl(0); fgt[1].tz = fdbl(12000); 
    fgt[1].ax = fdbl(1000); fgt[1].ay = fdbl(300); fgt[1].az = fdbl(10000); 
    fgt[2].state=2; fgt[2].role=1; fgt[2].tgn=-1; 
    fgt[2].tx = fdbl(5000); fgt[2].ty = fdbl(0); fgt[2].tz = fdbl(12000); 
    fgt[2].ax = fdbl(5700); fgt[2].ay = fdbl(100); fgt[2].az = fdbl(10000); 
    fgt[3].state=2; fgt[3].role=1; fgt[3].tgn=-1; 
    fgt[3].tx = fdbl(9800+5); fgt[3].ty = fdbl(0); fgt[3].tz = fdbl(11005); 
    fgt[3].ax = fdbl(9000); fgt[3].ay = fdbl(100); fgt[3].az = fdbl(11000); 
	nfgt = 4;    
   	
    LauncherSet(&(lns[0]), fdbl(-2050), fdbl(12560));
   	LauncherSet(&(lns[1]), fdbl(3070), fdbl(8000));
   	LauncherSet(&(lns[2]), fdbl(8120), fdbl(10000));
   	LauncherSet(&(lns[3]), fdbl(2020), fdbl(12150));
   	LauncherSet(&(lns[4]), fdbl(9170), fdbl(15000));
   	LauncherSet(&(lns[5]), fdbl(7120), fdbl(12000));
    nlns=6;
 
}

void MissionZrk5(World *w) WSEC;
void MissionZrk5(World *w)
{
	Int32 x,y;
 	if (w->grp[2].nobj==1 && w->grp[3].nobj==1) {
      	SetText("Mission complete!"); mcomplete=1;
  		return; //both radars dead
    }
 
  	if (viewstate==0 && !danger && w->grp[4].nobj>1 && my>fdbl(20)) {
       	x = fint(mx)+2000; y = fint(mz) - 11000;
       	x = isqrt(x*x + y*y);
       	if (x<5000) { // fire ZRK
          	RocketSend(7,-1,fdbl(-2000),fdbl(10),fdbl(11000));
        }
    }  	
  	if (viewstate==0 && !danger && w->grp[5].nobj>1 && my>fdbl(20)) {
       	x = fint(mx)-3000; y = fint(mz) - 9000;
       	x = isqrt(x*x + y*y);
       	if (x<5000) { // fire ZRK
          	RocketSend(7,-1,fdbl(3000),fdbl(10),fdbl(9000));
        }
    }  	
  	if (viewstate==0 && !danger && w->grp[6].nobj>1 && my>fdbl(20)) {
       	x = fint(mx)-8000; y = fint(mz) - 11000;
       	x = isqrt(x*x + y*y);
       	if (x<5000) { // fire ZRK
          	RocketSend(7,-1,fdbl(8000),fdbl(10),fdbl(11000));
        }
    }  	
}

void MissionAct5(World *w, UInt32 tick) WSEC;
void MissionAct5(World *w, UInt32 tick)
{
	Int32 ang;
 	dbl dx,dy;
    dbl X=fdbl(2000+2),Z=fdbl(12005);
    ang = tick%360; 
    while(ang<0) ang+=360;
    dx = fmul(cosa[ang],fdbl(10));
    dy = fmul(sina[ang],fdbl(10));
  
            if (w->grp[2].visible && w->grp[2].nobj>1) { 
	           	w->grp[2].obj[2].dots[0].ax=X-dx; w->grp[2].obj[2].dots[0].az=Z-dy;
    	       	w->grp[2].obj[2].dots[3].ax=X-dx; w->grp[2].obj[2].dots[3].az=Z-dy;
        	   	w->grp[2].obj[2].dots[1].ax=X+dx; w->grp[2].obj[2].dots[1].az=Z+dy;
           		w->grp[2].obj[2].dots[2].ax=X+dx; w->grp[2].obj[2].dots[2].az=Z+dy;
             }

            if (w->grp[3].visible && w->grp[3].nobj>1) { 
                X=fdbl(9000+2); Z=fdbl(15005);
	           	w->grp[3].obj[2].dots[0].ax=X-dx; w->grp[3].obj[2].dots[0].az=Z-dy;
    	       	w->grp[3].obj[2].dots[3].ax=X-dx; w->grp[3].obj[2].dots[3].az=Z-dy;
        	   	w->grp[3].obj[2].dots[1].ax=X+dx; w->grp[3].obj[2].dots[1].az=Z+dy;
           		w->grp[3].obj[2].dots[2].ax=X+dx; w->grp[3].obj[2].dots[2].az=Z+dy;
             }
}

void MissionDestroy5(Int16 tgn) WSEC;
void MissionDestroy5(Int16 tgn)
{
  switch(tgn) {
     case 2:
     case 3:SetText("Radar is destroyed.");
     break;
     case 4:
     case 5:
     case 6: SetText("Zrk is destroyed.");
     break;
    }
}

void MissionMap5(World *w) WSEC;
void MissionMap5(World *w)
{
	EventType e;
 	Int32 x,y, cx,cy, fcx[16], fcy[16], i, rd;
  	Char capt[]="AARRZZZFFFF";
 
	rd=1;

	WinEraseWindow();
 	for(x=0; x<w->ngrp; x++)
		WinDrawChars(&(capt[x]), 1, fint(w->grp[x].cx)/125+54, 122- fint(w->grp[x].cz)/125); 	
 
 	WinDrawChars("A-Airbase, F-Farm", 17, 2, 140);
 	WinDrawChars("R-Radar, Z-Zrk", 14, 2, 150);
	
 	cx = fint(w->grp[4].cx)/125+56; cy = 128- fint(w->grp[4].cz)/125;
 	for(x=0;x<36;x++)
  		WinDrawPixel(cx + fint(fmul(cosa[x*10],fdbl(40))), cy + fint(fmul(sina[x*10],fdbl(40))));
 	cx = fint(w->grp[5].cx)/125+56; cy = 128- fint(w->grp[5].cz)/125;
 	for(x=0;x<36;x++)
  		WinDrawPixel(cx + fint(fmul(cosa[x*10],fdbl(40))), cy + fint(fmul(sina[x*10],fdbl(40))));
 	cx = fint(w->grp[6].cx)/125+56; cy = 128- fint(w->grp[6].cz)/125;
 	for(x=0;x<36;x++)
  		WinDrawPixel(cx + fint(fmul(cosa[x*10],fdbl(40))), cy + fint(fmul(sina[x*10],fdbl(40))));
  
    
    for(x=0;x<160;x++) {
        if (x&2) continue;
        WinDrawPixel(x,100);
    }
    
    cx = fint(mx)/125+56; cy = 128- fint(mz)/125;
    x = fint(fmul(sina[fint(mKurs)],fdbl(5)));     y = fint(fmul(-cosa[fint(mKurs)],fdbl(5)));
	for(i=0;i<nfgt;i++) {
	    fcx[i] = fint(fgt[i].ax)/125+56; fcy[i] = 128- fint(fgt[i].az)/125;
    }    

 	if (rd){
      for(i=0;i<nfgt;i++)
      	if (fgt[i].state>0 && fcx[i]>=0 && fcx[i]<160 && fcy[i]>=0 && fcy[i]<160) {
	      WinInvertLine(fcx[i],fcy[i],fcx[i]+1,fcy[i]);
	      WinInvertLine(fcx[i],fcy[i]+1,fcx[i]+1,fcy[i]+1);
        }
    } else
        WinDrawChars("No radar info!", 14, 2, 1);
 do {
      EvtGetEvent (&e, 40);
      if (cx>=0 && cx<160 && cy>=0 && cy<160) {
	      WinInvertLine(cx,cy,cx+x,cy+y);
       	  WinInvertLine(cx+y/2, cy-x/2, cx-y/2, cy+x/2);
      }
      if (rd)
      for(i=0;i<nfgt;i++)
      	if (fgt[i].state>0 && fcx[i]>=0 && fcx[i]<160 && fcy[i]>=0 && fcy[i]<160) {
	      WinInvertLine(fcx[i],fcy[i],fcx[i]+1,fcy[i]);
	      WinInvertLine(fcx[i],fcy[i]+1,fcx[i]+1,fcy[i]+1);
        }
      //SysHandleEvent (&e);
    } while (e.eType!=keyDownEvent && e.eType!=penDownEvent);
}


void MissionBrief5(World *w) WSEC2;
void MissionBrief5(World *w)
{
	Char *s;
 	RectangleType rc;
  	Int16 done=0;
   	EventType e;
 	WinEraseWindow();
	WinDrawChars("MISSION BRIEFING",16,30,0);
	s = "We're planning a massive attack";
 	WinDrawChars(s, StrLen(s), 5, 10);
	s = "against the enemy but they've";
 	WinDrawChars(s, StrLen(s), 5, 20); 
	s = "got a good anti-aircraft defence.";
 	WinDrawChars(s, StrLen(s), 5, 30); 
	s = "We can't send our forces while";
 	WinDrawChars(s, StrLen(s), 5, 40); 
	s = "that defence is functioning.";
 	WinDrawChars(s, StrLen(s), 5, 50); 
	s = "You must blind it by destroying";
 	WinDrawChars(s, StrLen(s), 5, 60); 
	s = "both enemy radars. To pass";
 	WinDrawChars(s, StrLen(s), 5, 70); 
	s = "safely through danger zones of";
 	WinDrawChars(s, StrLen(s), 5, 80); 
	s = "ZRKs your altitude must be below";
 	WinDrawChars(s, StrLen(s), 5, 90); 
	s = "20 meters.";
 	WinDrawChars(s, StrLen(s), 5, 100); 

    rc.topLeft.x=120; rc.topLeft.y=140;
    rc.extent.x=20; rc.extent.y=15;
  	WinDrawRectangle(&rc,5);
   	WinEraseChars("Go",2,123,142);
    
    rc.topLeft.x=30; rc.topLeft.y=140;
    rc.extent.x=25; rc.extent.y=15;
  	WinDrawRectangle(&rc,5);
   	WinEraseChars("Map",3,33,142);
    
    do {
      EvtGetEvent (&e, evtWaitForever);
      //SysHandleEvent (&e);
	  if (e.eType == penDownEvent && e.screenY >140 && e.screenY <152 && e.screenX>120) done=1;
   	  if (e.eType == penDownEvent && e.screenY >140 && e.screenY <152 && e.screenX<80) {
      	MissionMap5(w);
       	MissionBrief5(w);
        done=1;
      }
    } while (!done);
}

